<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kaan79bbbx80h17lcc5ay919l5r6bqlz-vendored-sources/syn-1.0.98/src/ext.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>ext.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../storage.js"></script><script defer src="../../source-script.js"></script><script defer src="../../source-files.js"></script><script defer src="../../main.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../syn/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../syn/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../syn/index.html"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
<span id="92">92</span>
<span id="93">93</span>
<span id="94">94</span>
<span id="95">95</span>
<span id="96">96</span>
<span id="97">97</span>
<span id="98">98</span>
<span id="99">99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
</pre><pre class="rust"><code><span class="doccomment">//! Extension traits to provide parsing methods on foreign types.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! *This module is available only if Syn is built with the `&quot;parsing&quot;` feature.*</span>

<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::buffer::Cursor</span>;
<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::parse::Peek</span>;
<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::parse</span>::{<span class="ident">ParseStream</span>, <span class="prelude-ty">Result</span>};
<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::sealed::lookahead</span>;
<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::token::CustomToken</span>;
<span class="kw">use</span> <span class="ident">proc_macro2::Ident</span>;

<span class="doccomment">/// Additional methods for `Ident` not provided by proc-macro2 or libproc_macro.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This trait is sealed and cannot be implemented for types outside of Syn. It</span>
<span class="doccomment">/// is implemented only for `proc_macro2::Ident`.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// *This trait is available only if Syn is built with the `&quot;parsing&quot;` feature.*</span>
<span class="kw">pub</span> <span class="kw">trait</span> <span class="ident">IdentExt</span>: <span class="ident">Sized</span> <span class="op">+</span> <span class="ident">private::Sealed</span> {
    <span class="doccomment">/// Parses any identifier including keywords.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// This is useful when parsing macro input which allows Rust keywords as</span>
    <span class="doccomment">/// identifiers.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// # Example</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// ```</span>
    <span class="doccomment">/// use syn::{Error, Ident, Result, Token};</span>
    <span class="doccomment">/// use syn::ext::IdentExt;</span>
    <span class="doccomment">/// use syn::parse::ParseStream;</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// mod kw {</span>
    <span class="doccomment">///     syn::custom_keyword!(name);</span>
    <span class="doccomment">/// }</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// // Parses input that looks like `name = NAME` where `NAME` can be</span>
    <span class="doccomment">/// // any identifier.</span>
    <span class="doccomment">/// //</span>
    <span class="doccomment">/// // Examples:</span>
    <span class="doccomment">/// //</span>
    <span class="doccomment">/// //     name = anything</span>
    <span class="doccomment">/// //     name = impl</span>
    <span class="doccomment">/// fn parse_dsl(input: ParseStream) -&gt; Result&lt;Ident&gt; {</span>
    <span class="doccomment">///     input.parse::&lt;kw::name&gt;()?;</span>
    <span class="doccomment">///     input.parse::&lt;Token![=]&gt;()?;</span>
    <span class="doccomment">///     let name = input.call(Ident::parse_any)?;</span>
    <span class="doccomment">///     Ok(name)</span>
    <span class="doccomment">/// }</span>
    <span class="doccomment">/// ```</span>
    <span class="kw">fn</span> <span class="ident">parse_any</span>(<span class="ident">input</span>: <span class="ident">ParseStream</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="self">Self</span><span class="op">&gt;</span>;

    <span class="doccomment">/// Peeks any identifier including keywords. Usage:</span>
    <span class="doccomment">/// `input.peek(Ident::peek_any)`</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// This is different from `input.peek(Ident)` which only returns true in</span>
    <span class="doccomment">/// the case of an ident which is not a Rust keyword.</span>
    <span class="attribute">#[<span class="ident">allow</span>(<span class="ident">non_upper_case_globals</span>)]</span>
    <span class="kw">const</span> <span class="ident">peek_any</span>: <span class="ident">private::PeekFn</span> <span class="op">=</span> <span class="ident">private::PeekFn</span>;

    <span class="doccomment">/// Strips the raw marker `r#`, if any, from the beginning of an ident.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">///   - unraw(`x`) = `x`</span>
    <span class="doccomment">///   - unraw(`move`) = `move`</span>
    <span class="doccomment">///   - unraw(`r#move`) = `move`</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// # Example</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// In the case of interop with other languages like Python that have a</span>
    <span class="doccomment">/// different set of keywords than Rust, we might come across macro input</span>
    <span class="doccomment">/// that involves raw identifiers to refer to ordinary variables in the</span>
    <span class="doccomment">/// other language with a name that happens to be a Rust keyword.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// The function below appends an identifier from the caller&#39;s input onto a</span>
    <span class="doccomment">/// fixed prefix. Without using `unraw()`, this would tend to produce</span>
    <span class="doccomment">/// invalid identifiers like `__pyo3_get_r#move`.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// ```</span>
    <span class="doccomment">/// use proc_macro2::Span;</span>
    <span class="doccomment">/// use syn::Ident;</span>
    <span class="doccomment">/// use syn::ext::IdentExt;</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// fn ident_for_getter(variable: &amp;Ident) -&gt; Ident {</span>
    <span class="doccomment">///     let getter = format!(&quot;__pyo3_get_{}&quot;, variable.unraw());</span>
    <span class="doccomment">///     Ident::new(&amp;getter, Span::call_site())</span>
    <span class="doccomment">/// }</span>
    <span class="doccomment">/// ```</span>
    <span class="kw">fn</span> <span class="ident">unraw</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">Ident</span>;
}

<span class="kw">impl</span> <span class="ident">IdentExt</span> <span class="kw">for</span> <span class="ident">Ident</span> {
    <span class="kw">fn</span> <span class="ident">parse_any</span>(<span class="ident">input</span>: <span class="ident">ParseStream</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="self">Self</span><span class="op">&gt;</span> {
        <span class="ident">input</span>.<span class="ident">step</span>(<span class="op">|</span><span class="ident">cursor</span><span class="op">|</span> <span class="kw">match</span> <span class="ident">cursor</span>.<span class="ident">ident</span>() {
            <span class="prelude-val">Some</span>((<span class="ident">ident</span>, <span class="ident">rest</span>)) =&gt; <span class="prelude-val">Ok</span>((<span class="ident">ident</span>, <span class="ident">rest</span>)),
            <span class="prelude-val">None</span> =&gt; <span class="prelude-val">Err</span>(<span class="ident">cursor</span>.<span class="ident">error</span>(<span class="string">&quot;expected ident&quot;</span>)),
        })
    }

    <span class="kw">fn</span> <span class="ident">unraw</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">Ident</span> {
        <span class="kw">let</span> <span class="ident">string</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">to_string</span>();
        <span class="kw">if</span> <span class="ident">string</span>.<span class="ident">starts_with</span>(<span class="string">&quot;r#&quot;</span>) {
            <span class="ident">Ident::new</span>(<span class="kw-2">&amp;</span><span class="ident">string</span>[<span class="number">2</span>..], <span class="self">self</span>.<span class="ident">span</span>())
        } <span class="kw">else</span> {
            <span class="self">self</span>.<span class="ident">clone</span>()
        }
    }
}

<span class="kw">impl</span> <span class="ident">Peek</span> <span class="kw">for</span> <span class="ident">private::PeekFn</span> {
    <span class="kw">type</span> <span class="ident">Token</span> <span class="op">=</span> <span class="ident">private::IdentAny</span>;
}

<span class="kw">impl</span> <span class="ident">CustomToken</span> <span class="kw">for</span> <span class="ident">private::IdentAny</span> {
    <span class="kw">fn</span> <span class="ident">peek</span>(<span class="ident">cursor</span>: <span class="ident">Cursor</span>) -&gt; <span class="ident">bool</span> {
        <span class="ident">cursor</span>.<span class="ident">ident</span>().<span class="ident">is_some</span>()
    }

    <span class="kw">fn</span> <span class="ident">display</span>() -&gt; <span class="kw-2">&amp;</span><span class="lifetime">&#39;static</span> <span class="ident">str</span> {
        <span class="string">&quot;identifier&quot;</span>
    }
}

<span class="kw">impl</span> <span class="ident">lookahead::Sealed</span> <span class="kw">for</span> <span class="ident">private::PeekFn</span> {}

<span class="kw">mod</span> <span class="ident">private</span> {
    <span class="kw">use</span> <span class="ident">proc_macro2::Ident</span>;

    <span class="kw">pub</span> <span class="kw">trait</span> <span class="ident">Sealed</span> {}

    <span class="kw">impl</span> <span class="ident">Sealed</span> <span class="kw">for</span> <span class="ident">Ident</span> {}

    <span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">PeekFn</span>;
    <span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">IdentAny</span>;

    <span class="kw">impl</span> <span class="ident">Copy</span> <span class="kw">for</span> <span class="ident">PeekFn</span> {}
    <span class="kw">impl</span> <span class="ident">Clone</span> <span class="kw">for</span> <span class="ident">PeekFn</span> {
        <span class="kw">fn</span> <span class="ident">clone</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="self">Self</span> {
            <span class="kw-2">*</span><span class="self">self</span>
        }
    }
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../" data-current-crate="syn" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>